import React, {Component} from 'react';
import './style/SideBar.css';
import { connect, Provider } from 'react-redux';
import { createStore, combineReducers } from 'redux';
import {Link} from 'react-router-dom';

// class Inbox extends Component {
// 	render(){
// 		return(

// 		)
// 	}
// }

class ListItems extends Component { // элемент списка
	render(){
		let countStyle = {display: 'inline-block'};
		if (this.props.item.count === 0) {
			countStyle = {display: 'none'}
		}
 		return(
			<li><Link to={`/${this.props.item.type}/${this.props.item.project}`}><div className="projectColor" style={this.props.item.color}></div>{this.props.item.project}<i style={{display: countStyle.display,
																																													paddingLeft: '20px',
																																													color: 'red',
																																													fontSize: '18px',
			}}>{this.props.item.count}</i></Link></li>																																
		)
	}
}

class ListBar extends Component {  //компонент списка, в map передача в пропс массива для отдельных элементов списка
	render(){
		return(
			<ul className='listSideBar' style={{padding: 0}}>
				{this.props.items.itemList.map((item, index) => <ListItems item={item} key={index}/>)} 
			</ul>
		)
	}	
}

class SideBarList extends Component{ // компонент оглавления выпадающего списка, в List передача массива обьктов для выпадающего списка
	constructor(props){
		super(props);
		this.click = this.click.bind(this);
		this.state = {
			isOpen: true
		}
	}
	click(){
		this.setState({
			isOpen: !this.state.isOpen
		})
		
	}
	render(){
		
		let elem = this.state.isOpen && <ListBar items={this.props.item}/>; 
		return(
			
			<div className={this.props.item.text}>
					<svg width="12px" height="6px" viewBox="0 0 12 6" onClick={this.click}>
						<g transform="translate(-396.000000, -235.000000)" fill="#777777">
							<g transform="translate(128.000000, 213.000000)">
								<path  d="M280,22.7581818 L279.1564,22 L273.9922,26.506 L273.4414,26.0254545 L273.4444,26.0281818 L268.8562,22.0245455 L268,22.7712727 C269.2678,23.878 272.8084,26.9674545 273.9922,28 C274.8718,27.2330909 274.0144,27.9809091 280,22.7581818"></path>
							</g>
						</g>
					</svg>				
				<span onClick={this.click} style={{padding: '10px'}}>{this.props.item.name}</span>
				{elem}
			</div>
			
		)
	}	
}
class SideBarElem extends Component { // компонент не изменяемых дивок
	render(){
		let countStyle = {display: 'inline-block'};
		if (this.props.item.count === 0) {
			countStyle = {display: 'none'}
		}
		return(
			<div className={this.props.item.text} >
				<Link to={`/${this.props.item.category}/${this.props.item.project}`}><span className={this.props.item.icon}></span><span>{this.props.item.project}</span><i style={{display: countStyle.display,
																																													paddingLeft: '20px',
																																													color: 'red',
																																													fontSize: '18px',
				}}>{this.props.item.count}</i></Link>

			</div>
		)
	}
}


class SideBar extends Component { // первый элемент не изменяемые дивки , второй элемент выпадающий список в него попадает масив обьктов ключ itemsList еще один массив обьктов для списка
	render(){
		console.log('PROPS',this.props)
		return(
		<aside id="sideBar">	
			<div className='containerSaidBar'>
				<div>
				<Link to='/Map'><span className='fas fa-map'></span><span>Map</span></Link>
				</div>
				{this.props.store.x.itemsElem.map((item,index)=> <SideBarElem key={index} item={item} />)} 
				{this.props.store.x.itemsList.map((item,index)=> <SideBarList key={index} item={item} />)} 
			</div>
		</aside>
		)
	}
}
// const makePropsToToDo = function(store){
// 	return{
// 		itemsToDo: store.todo.items,
// 		itemsList: store.x.itemsList,
// 		itemsElem: store.x.itemsElem
// 	}
// }
export default SideBar;