import React, {Component} from 'react';
import './style/ToDo.css';
import { connect, Provider } from 'react-redux';
import { createStore, combineReducers } from 'redux';
import SideBar from './SideBar';

import {Router, Route} from 'react-router-dom';
import createHistory from 'history/createBrowserHistory';

const _ = require("lodash");
const { compose, withProps, lifecycle } = require("recompose");
const {withScriptjs, withGoogleMap, GoogleMap,Marker,} = require("react-google-maps");
const { SearchBox } = require("react-google-maps/lib/components/places/SearchBox");
/*global google*/


// import DatePicker from 'react-datepicker';
// import moment from 'moment';
// import SideBar from './SideBar'

/*									OBJ FOR STORE 						*/	 	
let todoList = {
    Category:{
    	Work:[],
    	Learn:[],
    	Travel:[],
    	Family:[],
    	Inbox:[],
    },
    Priority:{
    	priority1:[],
    	priority2:[],
    	priority3:[],
    	priority4:[],
    },
};
let globalMap = []
const sideBarElem = [
    {category: 'Category',
    project: 'Inbox',
     icon: 'fas fa-inbox iconDiv',
     count: 0,
     list: []
    },
    // {category: 'Category',
    // project: 'Today',
    //  icon: 'far fa-calendar iconDiv',
    //  count: 0,
    //  list: []
    // },
    // {category: 'Category',
    // project: 'For Next 7 day',
    //  icon: 'far fa-calendar-alt iconDiv',
    //  count: 0,
    //  list: []
    // },
];
let sideBarList = [
    {name: 'Project',
     itemList: [
        {project: 'Work',
         color: {border: '2px solid #c3124c'},
         count: 0,
         list: [],
         type: 'Category'
        },
        {project: 'Travel',
         color: {border: '2px solid #6107f7'},
         count: 0,
         list: [],
         type: 'Category'
        },
        {project: 'Learn',
         color: {border: '2px solid #159a18'},
         count: 0,
         list: [],
         type: 'Category'
        },
        {project: 'Family',
         color: {border: '2px solid #17dee6'},
         count: 0,
         list: [],
         type: 'Category'
        }
     ]
    },
    {name: 'Priority',
     itemList: [
        {project: 'priority1',
         color: {background: '#b3a9a9'},
         countPriority: 1,
         count: 0,
         list: [],
         type: 'Priority',
        },
        {project: 'priority2',
         color: {background: '#9a5f5f'},
         countPriority: 2,
         count: 0,
         list: [],
         type: 'Priority',
        },
        {project: 'priority3',
         color: {background: '#ca2929'},
         countPriority: 3,
         count: 0,
         list: [],
         type: 'Priority',
        },
        {project: 'priority4',
         color: {background: '#f11212'},
         countPriority: 4,
         count: 0,
         list: [],
         type: 'Priority',
        }
     ]
    }
];
/*								STORE 					*/

function toDoReducers(state, action) {
	if(state === undefined){
		return {items: localStorage.getItem('todo')? JSON.parse(localStorage.todo): todoList,
				position: [],
				globalMap: localStorage.getItem('globalMap')? JSON.parse(localStorage.globalMap): globalMap
			}
	};
	if(action.type === 'Add_List'){
		console.log(state)
		return {items: { Category :  {...state.items.Category, [action.project]: [...state.items.Category[action.project], {text: action.text, styleProject: action.styleProject,countPriority: action.countPriority, timestamp: (new Date()).getTime(), position: [action.position],day: action.day, positionCenter: action.position,project: action.project, priority: action.priority}]},
						Priority: {...state.items.Priority, [action.priority]: [...state.items.Priority[action.priority], {text: action.text, countPriority: action.countPriority,styleProject: action.styleProject, timestamp: (new Date()).getTime(), position: [action.position],day: action.day, positionCenter: action.position, priority: action.priority, project: action.project }]},
	},
	globalMap: [...state.globalMap, {text: action.text, styleProject: action.styleProject, countPriority: action.countPriority, timestamp: (new Date()).getTime(), position: action.position, positionCenter: action.position, priority: action.priority, project: action.project }],
	position: state.position
}
	};
	if (action.type === 'ADD_POSITION') {
		return {items: state.items,
		position: action.position,
		globalMap: state.globalMap
		}
	}
	if(action.type === 'DELETE_LIST') {
		
		var items = {Category:{},
					Priority:{}
	};
		for(let key in state.items.Category){
			if (key !== action.project) {
				items.Category[key] = [...state.items.Category[key]]
			}else {
				for (let i = 0; i < state.items.Category[key].length; i++) {
					if (state.items.Category[key][i].timestamp === action.timestamp) {
				 		state.items.Category[key].splice(i,1);
				 		items.Category[key] = [...state.items.Category[key]]
				 	}
				}
			}
		}
		for(let key in state.items.Priority){
			if (key !== action.priority) {
				items.Priority[key] = [...state.items.Priority[key]]
			}else {
				for (let i = 0; i < state.items.Priority[key].length; i++) {
					if (state.items.Priority[key][i].timestamp === action.timestamp) {
				 		state.items.Priority[key].splice(i,1);
				 		items.Priority[key] = [...state.items.Priority[key]]
				 	}
				}
			}
		}
		return{items,
			position: state.position,
			globalMap: state.globalMap 
		};
	}
	if (action.type === 'DELETE_POSITION') {
		let arr = [];
		for (var i = 0; i < state.globalMap.length; i++) {
			if (state.globalMap[i].timestamp !== action.timestamp) {
				arr.push(state.globalMap[i])
			}
		}
		return {
			items: state.items,
			position: [],
			globalMap: arr
		}
	}
	if (action.type === 'EDIT_POSITION') {
		let arr = []
		for (var i = 0; i < state.globalMap.length; i++) {
			if (state.globalMap[i].timestamp === action.timestamp) {
				arr.push({text: action.text, styleProject: action.styleProject, countPriority: action.countPriority,timestamp: (new Date()).getTime(), position: action.position, positionCenter: action.position, priority: action.priority, project: action.project })
			} else{
				arr.push(state.globalMap[i])
			}
		}
		return {
			items: state.items,
			position: [],
			globalMap: arr
		}
	}
	if (action.type === 'EDIT_LIST') {
		var items = {Category:{},
					Priority:{}
	};
		for(let key in state.items.Category){
			if (key !== action.privProject) {
				items.Category[key] = [...state.items.Category[key]]
				
			}else {
				for (let i = 0; i < state.items.Category[key].length; i++) {
					if (state.items.Category[key][i].timestamp === action.timestamp) {
						
						if (action.privProject === action.project) {
							items.Category[key] = state.items.Category[key];
							items.Category[key].splice(i,1, {text: action.text,countPriority: action.countPriority, styleProject: action.styleProject, timestamp: (new Date()).getTime(),  position: [action.position],day: action.day, positionCenter: action.position,project: action.project, priority: action.priority})
						}
						state.items.Category[key].splice(i,1);
						items.Category[key] = [...state.items.Category[key]];
					}
				}
			}
		}
		items.Category[action.project].push({text: action.text,countPriority: action.countPriority, styleProject: action.styleProject, timestamp: (new Date()).getTime(), position: [action.position],day: action.day, positionCenter: action.position,project: action.project, priority: action.priority})
		for(let key in state.items.Priority){
			if (key !== action.privPriority) {
				items.Priority[key] = [...state.items.Priority[key]]
				
			}else {
				for (let i = 0; i < state.items.Priority[key].length; i++) {
					if (state.items.Priority[key][i].timestamp === action.timestamp) {
						
						if (action.privPriority === action.priority) {
							items.Priority[key] = state.items.Priority[key];
							items.Priority[key].splice(i,1, {text: action.text, countPriority: action.countPriority, styleProject: action.styleProject, timestamp: (new Date()).getTime(), position: [action.position],day: action.day, positionCenter: action.position,project: action.project, priority: action.priority})
						}
						state.items.Priority[key].splice(i,1);
						items.Priority[key] = [...state.items.Priority[key]];
					}
				}
			}
		}
		items.Priority[action.priority].push({text: action.text, styleProject: action.styleProject, countPriority: action.countPriority, timestamp: (new Date()).getTime(), position: [action.position],day: action.day, positionCenter: action.position,project: action.project, priority: action.priority})
		return{items,
			position: state.position,
			globalMap: state.globalMap 
		};
	}
	return state;
};

function sideBarReducers(state,action){
	if (state === undefined) {
		return state = {itemsList: localStorage.getItem('itemsList')? JSON.parse(localStorage.itemsList) : sideBarList,
						itemsElem: localStorage.getItem('itemsElem')? JSON.parse(localStorage.itemsElem) : sideBarElem
						}
	}
	if (action.type === 'TO_PROJECT') {
		state.itemsList[0].itemList.map(function(item){
			if (action.project === item.project) {
				item.count += 1
			}
		})
		state.itemsElem.map(function(item){
			if (action.project === item.project) {
				item.count += 1
			}
		})
		state.itemsList[1].itemList.map(function(item){
			if (action.priority === item.project) {
				item.count += 1
			}
		})
	}


	if (action.type === 'DELETE_LIST_ON_PROJECT') {
		state.itemsList[0].itemList.map(function(item, index){
			if (action.project === item.project) {
				item.count -= 1;
			}
		})

		state.itemsElem.map(function(item, index){
			if (action.project === item.project) {
				item.count -= 1;
			}
		})
		state.itemsList[1].itemList.map(function(item, index){
			if (action.priority === item.project) {
				item.count -= 1;
			}
		})
	}
	return state;
}

const reducers = combineReducers({
	todo: toDoReducers,
	x: sideBarReducers
});
var store = createStore(reducers);
store.subscribe(() => {
	let state = store.getState()
	localStorage.todo = JSON.stringify(state.todo.items);
	localStorage.globalMap = JSON.stringify(state.todo.globalMap);
	localStorage.itemsList = JSON.stringify(state.x.itemsList);
	localStorage.itemsElem = JSON.stringify(state.x.itemsElem)
})



/*											Components							*/



class List extends Component {
	constructor(props){
		super(props);
		this.delete = this.delete.bind(this);
		this.edit = this.edit.bind(this);
		this.cancel = this.cancel.bind(this);
		this.clickMap = this.clickMap.bind(this);
		this.state = {
			editStyle: false,
			listStyle: {display: 'inline-block'},
			openMap: false
		}
	}
	delete(){
		let action1 = {
			type: 'DELETE_LIST',
			timestamp: this.props.item.timestamp,
			project: this.props.item.project,
			priority: this.props.item.priority 
		};
		store.dispatch(action1);
		console.log('Store', store.getState())
		let action2 = {
			type: 'DELETE_LIST_ON_PROJECT',
			project: this.props.item.project,
			category: this.props.item.project,
			priority: this.props.item.priority
		};
		store.dispatch(action2);
		let action3 = {
			type: 'DELETE_POSITION',
			timestamp: this.props.item.timestamp,
		}
		store.dispatch(action3);
	}
	edit(){
		this.setState({
			editStyle: true,
			listStyle: {display: 'none'}
		})
	}
	cancel(){
		this.setState({editStyle: false,
					listStyle: {display: 'inline-block'}
		})
	}
	clickMap(){
		this.setState({
			openMap: !this.state.openMap
		})
	}
	render(){
		console.log(this.props.item)
		var marker = true;
		if (this.props.item.positionCenter.length === 0) {
			marker = false;
			var markerF = 49.988358; 
			var markerB = 36.232845;
		} else{
		var markerF = this.props.item.position[0].f;
		var markerB = this.props.item.position[0].b;
		}
		console.log('PROPS_ON_LIST', this.props.item)
		let elem = this.state.editStyle && <FormEdit cancel={this.cancel} item={this.props.item}/>
		let elemMap = this.state.openMap && <MapWithAMarker
					 googleMapURL="https://maps.googleapis.com/maps/api/js?key=AIzaSyC4R6AN7SmujjPUIGKdyao2Kqitzr1kiRg&v=3.exp&libraries=geometry,drawing,places"
					  loadingElement={<div style={{ height: `100%`,
					  								width: '300px'
					  }} />}
					  containerElement={<div style={{ height: `400px`,
					  								width: '300px'
					   }} />}
					  mapElement={<div style={{ height: `100%`,
					  							width: '300px'
					   }} />}
					  item={this.props.item}
					  centeF={markerF}
					  centerB={markerB}
					  noMarker={marker}
					/>
		let arr = [];
		for (var i = 0; i < this.props.item.countPriority; i++) {
			arr[i] = [];
		};
		return(
			<div>
				{elem}
				<div style={{display: this.state.listStyle.display,
							paddingleft: '20px'
				}} className='div-list'>
					 <span type='checkbox' onClick={this.delete} className='list-delete' style={this.props.item.styleProject}></span>
					<span className='list'>{this.props.item.text}</span>
					<i className='fas fa-location-arrow form-icon' onClick={this.clickMap}></i>
					{arr.map((item, index) => <i className='fas fa-tint' key={index}></i>)}
					<span onClick={this.edit} className='add-list'>Edit</span>
					{elemMap}
				</div>
			</div>
		)
	}

}
// 
class FormEdit extends Component {
	constructor(props){
		super(props);
		this.click = this.click.bind(this)
		this.clickMap = this.clickMap.bind(this);
		this.edit = this.edit.bind(this);

		this.clickDate = this.clickDate.bind(this);
		// this.blurDate = this.blurDate.bind(this);
		this.selectDate = this.selectDate.bind(this);

		this.clickPriority = this.clickPriority.bind(this);
		this.prioritySelect = this.prioritySelect.bind(this);

		this.clickProject = this.clickProject.bind(this);
		this.selectProject = this.selectProject.bind(this);
		this.blur = this.blur.bind(this);
		// this.clickOption = this.clickOption.bind(this);
		this.state = {
			fiters: store.getState().x.itemsList[1].itemList,
			priority: store.getState().x.itemsList[1].itemList,
			items: store.getState().x.itemsList[0].itemList,
			styleText: {background: 'width'},
			openMap: false,
			openDate: {display:'none'},
			openPriority: {display:'none'},
			openProject: {display:'none'},
	};
}
	clickMap(){
		this.setState({
			openMap: !this.state.openMap
		})
	}
	clickDate(){
		this.setState({
			openDate: {display: 'inline-block'}
		})
	}
	selectDate(){
		this.setState({
			openDate: {display: 'none'}
		})
	}
	// blurDate(){
	// 	this.setState({
	// 		openDate: {display: 'none'}
	// 	})
	// }
	clickPriority(){
		this.setState({
			openPriority: {display: 'inline-block'}
		})
	}
	prioritySelect(){
		this.setState({
			openPriority: {display: 'none'}
		})
	}
	clickProject(){
		this.setState({
			openProject: {display: 'inline-block'}
		})
	}
	selectProject(){
		this.setState({
			openProject: {display: 'none'}
		})
	}
	blur(){
	}
	click(){
		this.props.cancel()
	}
	edit(){
		if (this.text.value !== '') {
			for (var i = 0; i < this.state.items.length; i++) {
				if(this.state.items[i].project === this.select.value) {
					var getProject = this.state.items[i].project;
				}
				if (this.select.value === 'Inbox') {
					var getProject = 'Inbox';
				}
			}
			for (var j = 0; j < this.state.priority.length; j++) {
				if (this.state.priority[j].project === this.proritySelect.value) {
					var getPriority = this.state.priority[j].project;
				}
			}
			let action1 = {
				type: 'EDIT_LIST',
				text: this.text.value,
				day: this.date.value,
				position: this.props.item.position[0],
				project: getProject,
				privProject: this.props.item.project,
				priority: getPriority,
				privPriority: this.props.item.priority,
				timestamp: this.props.item.timestamp,
				styleProject: this.props.item.styleProject,
				countPriority: this.props.item.countPriority
			}
			store.dispatch(action1);
			let action2 = {
				type: 'TO_PROJECT',
				project: getProject,
				priority: getPriority
			};
			store.dispatch(action2);
			let action3 ={
				type: 'DELETE_LIST_ON_PROJECT',
				project: this.props.item.project,
				priority: this.props.item.priority
			};
			store.dispatch(action3);
			let action4 = {
				type: 'EDIT_POSITION',
				text: this.text.value,
				day: this.date.value,
				position: this.props.item.position[0],
				project: getProject,
				priority: getPriority,
				timestamp: this.props.item.timestamp,
				styleProject: this.props.item.styleProject,
				countPriority: this.props.item.countPriority
			}
			store.dispatch(action4)
			console.log('STORE', store.getState())
			this.setState({
				openOption: !this.state.openOption,
				optionStyle: {display: 'inline-block'}
			})
		}else{
			this.setState({styleText: {'background': 'red'}})
		}
	}
	render(){
		console.log('EDIT_PROPS',this.props.item)
		var marker = true;
		if (this.props.item.position.length === 0) {
			marker = false;
			var markerF = 49.988358; 
			var markerB = 36.232845;

		} else{
		var markerF = this.props.item.position[0].f;
		var markerB = this.props.item.position[0].b;
		}
		let elem = this.state.editStyle && <FormEdit cancel={this.cancel} item={this.props.item}/>
		let componentMap = this.state.openMap && <MapForEdit item={this.props.item} centeF={markerF} centerB={markerB} noMarker={marker}/>;
		return(
			<div className='form' style={{paddingTop: '20px',
    									paddingLeft: '280px',
    								}}>
					<input  ref={x => this.text = x} style={{background: this.state.styleText.background,
															outline: 'none',
															width: '300px',
    														height: '40px',
    														fontSize: '15px',
    														fontWeight: '700',
					}} defaultValue={this.props.item.text}/>
					<span className='add-list' onClick={this.edit} >Edit</span>
					<span onClick={this.click}>Cancel</span>
					<div className='option-form'>
						<i className='fas fa-briefcase form-icon' onClick={this.clickProject}></i>
						<select ref={x => this.select = x} onChange={this.selectProject} style={this.state.openProject} defaultValue={this.props.item.project}>
							<option>Inbox</option>
							{store.getState().x.itemsList[0].itemList.map((item,index) => <SelectProject item={item} key={index}/>)}
						</select>
						<i className='fas fa-tint form-icon' onClick={this.clickPriority}></i>
						<select ref={x => this.proritySelect = x} style={this.state.openPriority} onChange={this.prioritySelect} onBlur={this.blur} defaultValue={this.props.item.priority}>
							{store.getState().x.itemsList[1].itemList.map((item, index) => <SelectProject item={item} key={index}/>)}
						</select>
						<i className='far fa-calendar-plus form-icon' onClick={this.clickDate} ></i>
						<input type='date' onInput={this.getDay} ref={x => this.date = x} style={this.state.openDate} onChange={this.selectDate} onBlur={this.blurDate} defaultValue={this.props.item.day}/>
						<i className='fas fa-location-arrow form-icon' onClick={this.clickMap}></i>
						{componentMap}
				</div>
			</div>
		)
	}
}

// lat: 49.988358, lng: 36.232845
const MapForEdit = compose(
  withProps({
    googleMapURL: "https://maps.googleapis.com/maps/api/js?key=AIzaSyC4R6AN7SmujjPUIGKdyao2Kqitzr1kiRg&v=3.exp&libraries=geometry,drawing,places",
    loadingElement: <div style={{ height: `100%` }} />,
    containerElement: <div style={{ height: `400px` }} />,
    mapElement: <div style={{ height: `100%` }} />,
  }),
  lifecycle({
    componentWillMount() {
      const refs = {};
      this.setState({
        bounds: null,
        center: {
          lat: 49.988358, lng: 36.232845
        },
        markers: [],
        onMapMounted: ref => {
          refs.map = ref;
        },
        onBoundsChanged: () => {
          this.setState({
            bounds: refs.map.getBounds(),
            center: refs.map.getCenter(),
          })
        },
        onSearchBoxMounted: ref => {
          refs.searchBox = ref;
        },
        onPlacesChanged: () => { // ставит маркер на нужную позицию
          const places = refs.searchBox.getPlaces();// обькт из которого можно взять маркер places[0].geometry
          const bounds = new google.maps.LatLngBounds();

          let pointf = (bounds.extend(places[0].geometry.location).f.f + bounds.extend(places[0].geometry.location).f.b)/2;
          let pointb = (bounds.extend(places[0].geometry.location).b.f + bounds.extend(places[0].geometry.location).b.b)/2;
          let action = {
          	type: 'ADD_POSITION',
          	position: {
          		b: pointb,
          		f: pointf
          	}
          }
          store.dispatch(action)

          places.forEach(place => {
            if (place.geometry.viewport) {
              bounds.union(place.geometry.viewport)
            } else {
              bounds.extend(place.geometry.location)
            }
          });
          const nextMarkers = places.map(place => ({
            position: place.geometry.location,
          }));
          console.log(this.markers)
          const nextCenter = _.get(nextMarkers, '0.position', this.state.center);

          this.setState({
            center: nextCenter,
            markers: nextMarkers,
          });
          // refs.map.fitBounds(bounds);
        },
      })
    },
  }),
  withScriptjs,
  withGoogleMap
)(props =>

  <GoogleMap ref={props.onMapMounted} defaultZoom={15} center={{ lat: props.centeF, lng: props.centerB}} onBoundsChanged={props.onBoundsChanged}>
    <SearchBox ref={props.onSearchBoxMounted} bounds={props.bounds} controlPosition={google.maps.ControlPosition.TOP_LEFT} onPlacesChanged={props.onPlacesChanged}>
      <input type="text" placeholder="Adress"
   		style={{
          boxSizing: `border-box`,
          border: `1px solid transparent`,
          width: `240px`,
          height: `32px`,
          marginTop: `27px`,
          padding: `0 12px`,
          borderRadius: `3px`,
          boxShadow: `0 2px 6px rgba(0, 0, 0, 0.3)`,
          fontSize: `14px`,
          outline: `none`,
          textOverflow: `ellipses`,
        }}
      />
    </SearchBox>

     {props.noMarker && <Marker position={{lat:props.item.position[0].f, lng:props.item.position[0].b}}/>}

  </GoogleMap>	
);
const MapWithAMarker = compose(withScriptjs,
withProps({

}),
withGoogleMap)(props =>
  <GoogleMap
    defaultZoom={15}
    defaultCenter={{ lat: props.centeF, lng: props.centerB}}
    onPlacesChanged={props.onPlacesChanged}>
  >
   {props.noMarker && <Marker position={{lat:props.item.position[0].f, lng:props.item.position[0].b}}/>}
  </GoogleMap>
);
// 
class MainPage extends Component{
		constructor(props){
		super(props);
}
	render(){	
		return(
			<div>
				<SideBar store={store.getState()}/>
				<Form/>
			</div>
		)
	}
}

class MainList extends Component{
		constructor(props){
		super(props);
}
	render(){	
		let type = this.props.match.params.type;
		let name =  this.props.match.params.name;
		return(
			<div>
				{store.getState().todo.items[type][name].map((item, index) => <List item={item} key={index}/>)}
			</div>
		)
	}
}

class SelectProject extends Component{
	render(){
		return(
			<option>{this.props.item.project}</option>
		)
	}
}

// 
class Form extends Component {
	constructor(props){
		super(props);
		this.save = this.save.bind(this);

		this.clickMap = this.clickMap.bind(this);

		this.clickDate = this.clickDate.bind(this);
		// this.blurDate = this.blurDate.bind(this);
		this.selectDate = this.selectDate.bind(this);

		this.clickPriority = this.clickPriority.bind(this);
		this.prioritySelect = this.prioritySelect.bind(this);

		this.clickProject = this.clickProject.bind(this);
		this.selectProject = this.selectProject.bind(this);
		this.blur = this.blur.bind(this);
		this.clickOption = this.clickOption.bind(this);
		this.state = {
			fiters: store.getState().x.itemsList[1].itemList,
			priority: store.getState().x.itemsList[1].itemList,
			items: store.getState().x.itemsList[0].itemList,
			styleText: {background: 'width'},
			openMap: false,
			openDate: {display:'none'},
			openPriority: {display:'none'},
			openProject: {display:'none'},
			openOption: {display: 'none'},
			optionStyle: {display: 'inline-block'}
	};
}
// 
	save(){
				console.log(this.select.value)
		if (this.text.value !== '') {
			for (var i = 0; i < this.state.items.length; i++) {
				if(this.state.items[i].project === this.select.value) {
					var getProject = this.state.items[i].project;
					var styleProject = this.state.items[i].color;
				}
				if (this.select.value === 'Inbox') {
					var getProject = 'Inbox';
					var styleProject = {border: '2px solid #000'}
				}
			}
			for (var j = 0; j < this.state.priority.length; j++) {
				if (this.state.priority[j].project === this.proritySelect.value) {
					var getPriority = this.state.priority[j].project;
					var countPriority = this.state.priority[j].countPriority
				}
			}
			let action1 = {
				type: 'Add_List',
				text: this.text.value,
				day: this.date.value,
				position: store.getState().todo.position,
				project: getProject,
				priority: getPriority,
				timestamp: (new Date()).getTime(),
				styleProject: styleProject,
				countPriority: countPriority
			}
			console.log('fkajshvg',action1)
			store.dispatch(action1);
			let action2 = {
				type: 'TO_PROJECT',
				text: this.text.value,
				project: this.select.value,
				priority: this.proritySelect.value,
				day: this.date.value,
			}
			store.dispatch(action2);
			this.text.value = '';
			this.select.value = 'Inbox';
			this.proritySelect.value = 'priority1';
			console.log('save click',store.getState())
			this.setState({
				openOption: !this.state.openOption,
				optionStyle: {display: 'inline-block'}
			})
		}else{
			this.setState({styleText: {'background': 'red'}})
		}
	this.setState({
		openOption: {display: 'none'},
		optionStyle: {display: 'inline-block'}
	})
	}
	clickMap(){
		this.setState({
			openMap: !this.state.openMap
		})
	}
	clickDate(){
		this.setState({
			openDate: {display: 'inline-block'}
		})
	}
	selectDate(){
		this.setState({
			openDate: {display: 'none'}
		})
	}
	// blurDate(){
	// 	this.setState({
	// 		openDate: {display: 'none'}
	// 	})
	// }
	clickPriority(){
		this.setState({
			openPriority: {display: 'inline-block'}
		})
	}
	prioritySelect(){
		this.setState({
			openPriority: {display: 'none'}
		})
	}
	clickProject(){
		this.setState({
			openProject: {display: 'inline-block'}
		})
	}
	selectProject(){
		this.setState({
			openProject: {display: 'none'}
		})
	}
	blur(){
	}
	clickOption(){
		this.setState({
			openOption: {display: 'inline-block'},
			optionStyle: {display: 'none'}
		})
	}
	// inputOnFocus(event){
	// 	if (event.key === 'Enter') {
	// 		this.save()
	// 	}
	// }
	render(){
		let componentMap = this.state.openMap && <MapWithASearchBox/>;
		return(
			<div className='form'>
				<span className='add-list'onClick={this.clickOption} style={this.state.optionStyle}><i className='fas fa-plus' ></i> Add New List</span>
				<div style={{display: this.state.openOption.display,
							paddingTop: '20px',
    						paddingLeft: '20px',
				}} >
					<input placeholder='Text To Do List' ref={x => this.text = x} style={{background: this.state.styleText.background,
																						outline: 'none',
																						width: '300px',
    																					height: '40px',
    																					fontSize: '15px',
    																					fontWeight: '700',
					}} />
					<span className='add-list' onClick={this.save} >Create</span>
					<div className='option-form'>
						<i className='fas fa-briefcase form-icon' onClick={this.clickProject}></i>
						<select ref={x => this.select = x} onChange={this.selectProject} style={this.state.openProject}>
							<option>Inbox</option>
							{store.getState().x.itemsList[0].itemList.map((item,index) => <SelectProject item={item} key={index}/>)}
						</select>
						<i className='fas fa-tint form-icon' onClick={this.clickPriority}></i>
						<select ref={x => this.proritySelect = x} style={this.state.openPriority} onChange={this.prioritySelect} onBlur={this.blur}>
							{store.getState().x.itemsList[1].itemList.map((item, index) => <SelectProject item={item} key={index}/>)}
						</select>
						<i className='far fa-calendar-plus form-icon' onClick={this.clickDate} ></i>
						<input type='date' onInput={this.getDay} ref={x => this.date = x} style={this.state.openDate} onChange={this.selectDate} onBlur={this.blurDate}/>
						<i className='fas fa-location-arrow form-icon' onClick={this.clickMap}></i>
						{componentMap}
					</div>
				</div>
			</div>
		)
	}
}





/*							TO RENDER 							*/

// 

const makePropsToToDo = function(store){
	return{
		itemsToDo: store.todo.items,
		itemsSideBarList: store.x.itemsList,
		itemsSideBarElem: store.x.itemsElem
	}
}
MainPage = connect(makePropsToToDo)(MainPage);
MainList = connect(makePropsToToDo)(MainList);		


class ToDoMain extends Component {
	constructor(props){
		super(props);
	}
	render(){
		return(
			<Router history={createHistory()}>
				<div>
					<Provider store={store}>
						<div className="container">
							<Route path='/' component={MainPage}/>
							<Route path='/:type/:name' component={MainList}/>
							<Route exact path='/Map' component={GlobalMap}/>
						</div>
					</Provider>
				</div>
			</Router>
		)
	}
}
export default ToDoMain



/*									MyGoogleMap 							*/

// defaultCenter={{ lat: 49.988358, lng: 36.232845 }} positin={{lat:36.157423719708504, lng:36.229699}} <MyMapComponent containerElement={<div style={{ height: `400px` }}/>} mapElement={<div style={{ height: `400px` }}/>} />


const MapWithASearch = compose(
  withProps({
    googleMapURL: "https://maps.googleapis.com/maps/api/js?key=AIzaSyC4R6AN7SmujjPUIGKdyao2Kqitzr1kiRg&v=3.exp&libraries=geometry,drawing,places",
    loadingElement: <div style={{ height: `100%`,
    							width: '500px'
     }} />,
    containerElement: <div style={{ height: `500px`,
    								width: '500px'
     }} />,
    mapElement: <div style={{ height: `100%`,
    						width: '500px'
     }} />,
  }),
  lifecycle({
    componentWillMount() {
      const refs = {};
      this.setState({
        bounds: null,
        center: {
          lat: 49.988358, lng: 36.232845
        },
        markers: [],
        onMapMounted: ref => {
          refs.map = ref;
        },
        onBoundsChanged: () => {
          this.setState({
            bounds: refs.map.getBounds(),
            center: refs.map.getCenter(),
          })
        },
        onSearchBoxMounted: ref => {
          refs.searchBox = ref;
        },
        onPlacesChanged: () => { // ставит маркер на нужную позицию
          const places = refs.searchBox.getPlaces();// обькт из которого можно взять маркер places[0].geometry
          const bounds = new google.maps.LatLngBounds();

          let pointf = (bounds.extend(places[0].geometry.location).f.f + bounds.extend(places[0].geometry.location).f.b)/2;
          let pointb = (bounds.extend(places[0].geometry.location).b.f + bounds.extend(places[0].geometry.location).b.b)/2;
          let action = {
          	type: 'ADD_POSITION',
          	position: {
          		b: pointb,
          		f: pointf
          	}
          }
          store.dispatch(action)

          places.forEach(place => {
            if (place.geometry.viewport) {
              bounds.union(place.geometry.viewport)
            } else {
              bounds.extend(place.geometry.location)
            }
          });
          const nextMarkers = places.map(place => ({
            position: place.geometry.location,
          }));
          console.log(this.markers)
          const nextCenter = _.get(nextMarkers, '0.position', this.state.center);

          this.setState({
            center: nextCenter,
            markers: nextMarkers,
          });
          // refs.map.fitBounds(bounds);
        },
      })
    },
  }),
  withScriptjs,
  withGoogleMap
)(props =>

  <GoogleMap ref={props.onMapMounted} defaultZoom={15} center={props.center} onBoundsChanged={props.onBoundsChanged}>
    <SearchBox ref={props.onSearchBoxMounted} bounds={props.bounds} controlPosition={google.maps.ControlPosition.TOP_LEFT} onPlacesChanged={props.onPlacesChanged}>
      <input type="text" placeholder="Adress"
   		style={{
          boxSizing: `border-box`,
          border: `1px solid transparent`,
          width: `240px`,
          height: `32px`,
          marginTop: `37px`,
          padding: `0 12px`,
          borderRadius: `3px`,
          boxShadow: `0 2px 6px rgba(0, 0, 0, 0.3)`,
          fontSize: `14px`,
          outline: `none`,
          textOverflow: `ellipses`,
        }}
      />
    </SearchBox>
    {props.markers.map((marker, index) => <Marker key={index} position={marker.position} />)}

  </GoogleMap>	
);

class MapWithASearchBox extends Component {
	render(){
		
		return(
			<MapWithASearch/>
		)
	}
}



// b,b нижняя левая ff верхняя правая fb нижняя правая

const { MarkerWithLabel } = require("react-google-maps/lib/components/addons/MarkerWithLabel");

const MapToDo = compose(
  withScriptjs,
  withGoogleMap
)(props =>
  <GoogleMap
    defaultZoom={8}
    defaultCenter={{ lat: 49.988358, lng: 36.232845 }}
  >
    {store.getState().todo.globalMap.map((item, index) => <MarkerWithLabel  key={index} position={{ lat: item.position.f, lng: item.position.b}} labelAnchor={new google.maps.Point(0, 0)} labelStyle={{backgroundColor: '#a1a7a7',border: item.styleProject.border,fontSize: "20px", padding: "6px", color: 'white', fontSize: '12px'}}>
      <div>
	      <span>{item.text}</span>
	      <span>  {item.priority}</span>
      </div>
    </MarkerWithLabel>)}
  </GoogleMap>
);


class GlobalMap extends Component {
	render(){
		
		return(
			<MapToDo
			  googleMapURL="https://maps.googleapis.com/maps/api/js?key=AIzaSyC4R6AN7SmujjPUIGKdyao2Kqitzr1kiRg&v=3.exp&libraries=geometry,drawing,places"
			  loadingElement={<div style={{ height: `100%` }} />}
			  containerElement={<div style={{ height: `400px` }} />}
			  mapElement={<div style={{ height: `100%` }} />}
			/>
		)
	}
}




